/*
 * RtpMediaConnection.java
 *
 * The Simple Media API RA
 *
 * The source code contained in this file is in in the public domain.
 * It can be used in any project or product without prior permission,
 * license or royalty payments. There is  NO WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR STATUTORY, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 * AND DATA ACCURACY.  We do not warrant or make any representations
 * regarding the use of the software or the  results thereof, including
 * but not limited to the correctness, accuracy, reliability or
 * usefulness of the software.
 */

package org.mobicents.slee.resource.media.ratype;

/**
 *
 * @author Oleg Kulikov
 */
public interface RtpMediaConnection extends MediaConnection {
    /**
     * Apply session descriptor of the remote party.
     *
     * @param sdp the remote session descriptor.
     */ 
    public void setRemoteDescriptor(String sdp) throws IllegalArgumentException;
    
    /**
     * Gets the remote party session descriptor.
     *
     * @return session desriptor by means of SDP.
     */
    public String getRemoteDescriptor();
    
    /**
     * Gets session descriptor of the local party.
     *
     * @return session descriptor by means of SDP.
     */
    public String getLocalDescriptor();
}
