/***************************************************
 *                                                 *
 *  Mobicents: The Open Source JSLEE Platform      *
 *                                                 *
 *  Distributable under LGPL license.              *
 *  See terms of license at gnu.org.               *
 *                                                 *
 ***************************************************/
/*
 * ProfileManagementInterceptor.java
 * 
 * Created on Oct 4, 2004
 *
 */
package org.mobicents.slee.container.deployment.interceptors;

import java.lang.reflect.Method;

import javax.slee.management.ManagementException;

import org.mobicents.slee.container.profile.SleeProfileManager;

/**
 * @author DERUELLE Jean <a href="mailto:jean.deruelle@gmail.com">jean.deruelle@gmail.com</a>
 *
 */
public interface ProfileManagementInterceptor {
    /* (non-Javadoc)
     * @see java.lang.reflect.InvocationHandler#invoke(java.lang.Object, java.lang.reflect.Method, java.lang.Object[])
     */
    public Object invoke(Object proxy, Method method, Object[] args)
            throws Throwable;
    /**
     * 
     * @param profileManagement
     */
    public void setProfileManager(SleeProfileManager profileManagement);
    /**
     * 
     * @return
     */
    public SleeProfileManager getProfileManager();
    /**
     * 
     * @param profile
     */
    public void setProfile(Object profile);
    /**
     * 
     * @return
     */
    public Object getProfile();
    /**
     * 
     * @param profileKey
     */
    public void setProfileKey(String profileKey);
    /**
     * 
     * @return
     */
    public String getProfileKey();
    
    
    /**
     * @param string
     */
    public void copyStateFromDefaultProfile(String profileCMPInterfaceName,String defaultProfileKey) throws ManagementException;
    
    /**
     * 
     */
    public void loadStateFromBackendStorage(String profileCMPInterfaceName) throws Exception;

    public void setProfileTableName(String profileTableName);
    public String getProfileTableName();

    public void setProfileName(String profileName);
    public String getProfileName();
    
    /**
     * Persist CMP attributes of a profile.
     * This method will look through the CMP fields in the 
     * transient state class generated by the slee
     * and store the fields of this class into the persistent storage.
     * 
     * @param profileTransientState
     * @throws Exception
     */
    public void persistProfile() throws Exception;
    
}
